'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactstrap = require('reactstrap');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PaginationComponent = function (_Component) {
    _inherits(PaginationComponent, _Component);

    function PaginationComponent(props) {
        _classCallCheck(this, PaginationComponent);

        var _this = _possibleConstructorReturn(this, (PaginationComponent.__proto__ || Object.getPrototypeOf(PaginationComponent)).call(this, props));

        _this.getNumberOfPages = function () {
            var auxPages = _this.props.totalItems / _this.props.pageSize;
            var pages = parseInt(auxPages, 10);
            pages += pages !== auxPages ? 1 : 0;
            return pages;
        };

        _this.paginationItems = function () {
            var items = [];
            _this.lastPaginationNumber = _this.getLastPaginationNumber();
            items.push(_this.firstOrLastPagItem("First", 1));
            items.push(_this.nextOrPreviousPagItem("Previous", 1, 'l'));
            for (var i = _this.state.firstPaginationNumber; i <= _this.lastPaginationNumber; i++) {
                items.push(_this.numberedPagItem(i));
            }
            items.push(_this.nextOrPreviousPagItem("Next", _this.pages, 'r'));
            items.push(_this.firstOrLastPagItem("Last", _this.pages));
            return items;
        };

        _this.getLastPaginationNumber = function () {
            var minNumberPages = Math.min(_this.pages, _this.props.maxPaginationNumbers);
            return _this.state.firstPaginationNumber + minNumberPages - 1;
        };

        _this.numberedPagItem = function (i) {
            return _react2.default.createElement(
                _reactstrap.PaginationItem,
                { key: i, id: 'pagebutton' + i, active: _this.state.activePage === i, onClick: _this.handleClick },
                _react2.default.createElement(
                    _reactstrap.PaginationLink,
                    { style: { minWidth: '43.5px' } },
                    i
                )
            );
        };

        _this.nextOrPreviousPagItem = function (name, page, direction) {
            return _react2.default.createElement(
                _reactstrap.PaginationItem,
                { key: name, disabled: _this.state.activePage === page, onClick: function onClick(e) {
                        return _this.handleSelectNextOrPrevious(direction);
                    } },
                _react2.default.createElement(
                    _reactstrap.PaginationLink,
                    null,
                    name
                )
            );
        };

        _this.firstOrLastPagItem = function (name, page) {
            var event = {
                currentTarget: {
                    getAttribute: function getAttribute() {
                        return 'pagebutton' + page;
                    }
                }
            };
            return _react2.default.createElement(
                _reactstrap.PaginationItem,
                { key: name, disabled: _this.state.activePage === page, onClick: function onClick() {
                        return _this.handleClick(event);
                    } },
                _react2.default.createElement(
                    _reactstrap.PaginationLink,
                    null,
                    name
                )
            );
        };

        _this.handleClick = function (event) {
            var newActivePage = parseInt(event.currentTarget.getAttribute("id").split("pagebutton").pop(), 10);
            _this.setState({
                activePage: newActivePage
            });
            _this.handlePaginationNumber(newActivePage);
            _this.props.onSelect(newActivePage);
        };

        _this.handleSelectNextOrPrevious = function (direction) {
            var activePage = _this.state.activePage;
            if (direction === 'r' && activePage === _this.pages || direction === 'l' && activePage === 1) return;

            var newActivePage = direction === 'r' ? activePage + 1 : activePage - 1;

            _this.setState({
                activePage: newActivePage
            });

            _this.handlePaginationNumber(newActivePage);
            _this.props.onSelect(newActivePage);
        };

        _this.handlePaginationNumber = function (activePage) {
            var distance = Math.floor(_this.props.maxPaginationNumbers / 2);
            var newFPNumber = activePage - distance;
            var newLPNumber = activePage + distance;
            if (newFPNumber <= 1) {
                if (_this.state.firstPaginationNumber !== 1) {
                    _this.setState({
                        firstPaginationNumber: 1
                    });
                }
            } else if (newLPNumber <= _this.pages) {
                _this.setState({
                    firstPaginationNumber: newFPNumber
                });
            } else if (newLPNumber >= _this.pages) {
                _this.setState({
                    firstPaginationNumber: _this.pages - _this.props.maxPaginationNumbers + 1
                });
            }
        };

        _this.state = {
            activePage: 1,
            firstPaginationNumber: 1
        };
        _this.pages = _this.getNumberOfPages();
        return _this;
    }

    _createClass(PaginationComponent, [{
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _reactstrap.Pagination,
                null,
                this.paginationItems()
            );
        }
    }]);

    return PaginationComponent;
}(_react.Component);

PaginationComponent.propTypes = {
    totalItems: _propTypes2.default.number.isRequired,
    pageSize: _propTypes2.default.number.isRequired,
    onSelect: _propTypes2.default.func.isRequired,
    maxPaginationNumbers: _propTypes2.default.number
};

PaginationComponent.defaultProps = {
    maxPaginationNumbers: 5
};

exports.default = PaginationComponent;